package org.jeecg.modules.stm.bcs.handle.controller;

import java.util.Arrays;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.stm.bcs.handle.service.IBcsEventOrgService;
import org.jeecg.modules.stm.bcs.handle.entity.BcsEventOrg;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;


import org.jeecg.common.aspect.annotation.AutoLog;

/**
 * @Description: 应用组织方案
 * @Author: jeecg-boot
 * @Date:   2025-09-25
 * @Version: V1.0
 */
  
@RestController
@RequestMapping("/bcs.handle/bcsEventOrg")
@Slf4j
public class BcsEventOrgController extends JeecgController<BcsEventOrg, IBcsEventOrgService> {
	@Autowired
	private IBcsEventOrgService bcsEventOrgService;
	
	/**
	 * 分页列表查询
	 *
	 * @param bcsEventOrg
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "应用组织方案-分页列表查询")
	  
	@GetMapping(value = "/list")
	public Result<IPage<BcsEventOrg>> queryPageList(BcsEventOrg bcsEventOrg,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<BcsEventOrg> queryWrapper = QueryGenerator.initQueryWrapper(bcsEventOrg, req.getParameterMap());
		Page<BcsEventOrg> page = new Page<BcsEventOrg>(pageNo, pageSize);
		IPage<BcsEventOrg> pageList = bcsEventOrgService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param bcsEventOrg
	 * @return
	 */
	@AutoLog(value = "应用组织方案-添加")
	  
	//@RequiresPermissions("bcs.handle:bcs_event_org:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody BcsEventOrg bcsEventOrg) {
		bcsEventOrgService.save(bcsEventOrg);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param bcsEventOrg
	 * @return
	 */
	@AutoLog(value = "应用组织方案-编辑")
	  
	//@RequiresPermissions("bcs.handle:bcs_event_org:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody BcsEventOrg bcsEventOrg) {
		bcsEventOrgService.updateById(bcsEventOrg);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "应用组织方案-通过id删除")
	  
	//@RequiresPermissions("bcs.handle:bcs_event_org:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		bcsEventOrgService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "应用组织方案-批量删除")
	  
	//@RequiresPermissions("bcs.handle:bcs_event_org:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.bcsEventOrgService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "应用组织方案-通过id查询")
	  
	@GetMapping(value = "/queryById")
	public Result<BcsEventOrg> queryById(@RequestParam(name="id",required=true) String id) {
		BcsEventOrg bcsEventOrg = bcsEventOrgService.getById(id);
		if(bcsEventOrg==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(bcsEventOrg);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param bcsEventOrg
    */
	// @RequiresPermissions("bcs.handle:bcs_event_org:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, BcsEventOrg bcsEventOrg) {
        return super.exportXls(request, bcsEventOrg, BcsEventOrg.class, "应用组织方案");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
	// @RequiresPermissions("bcs.handle:bcs_event_org:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, BcsEventOrg.class);
    }

}
